// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  crystal growth group                                                  ==
// ==                                                                        ==
// ==  Stiftung caesar                                                       ==
// ==  Ludwig-Erhard-Allee 2                                                 ==
// ==  53175 Bonn                                                            ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  http://www.caesar.de/cg/AMDiS                                         ==
// ==                                                                        ==
// ============================================================================

/** \file ValueReader.h */

#ifndef AMDIS_VALUEREADER_H
#define AMDIS_VALUEREADER_H

#include <cstring>
#include "DOFVector.h"
#include "Mesh.h"

namespace AMDiS {

  /** \ingroup Input
   *  
   * \brief
   * Static class which reads a value file in AMDiS format and copies
   * the data to a DOF vector.
   */ 
  class ValueReader
  {
  public:
    /// Copies the values of a value file to a DOF vector.
    static void readValue(std::string filename,
			  Mesh *mesh,
			  DOFVector<double> *dofVector,
			  MacroInfo *macroFileInfo);
  };

}

#endif
